package com.persagy.apm.dmpalarm.config;

import org.springframework.amqp.core.AcknowledgeMode;
import org.springframework.amqp.rabbit.config.SimpleRabbitListenerContainerFactory;
import org.springframework.amqp.rabbit.connection.ConnectionFactory;
import org.springframework.amqp.rabbit.listener.RabbitListenerContainerFactory;
import org.springframework.amqp.support.converter.Jackson2JsonMessageConverter;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

/**
 * @author: yaoll
 * @date: 2020-09-22
 * @verison: 1.0
 */
@Configuration
public class WebConfig implements WebMvcConfigurer {
	//@Bean  删除
	public DmpParameterStorage dmpParameterStorage() {
		return new DmpParameterStorage();
	}

	@Override
	public void addInterceptors(InterceptorRegistry registry) {
		// 设置拦截的路径、不拦截的路径、优先级等等
		registry.addInterceptor(dmpParameterStorage()).addPathPatterns("/**");
	}
//删除  与 RabbitMsgConfig 类中此方法重复  与 alarm-data-starter AutoConfiguration 重复
//	@Bean
//	public HttpMessageConverters customConverters() {
//		MappingJackson2HttpMessageConverter converter = new MappingJackson2HttpMessageConverter();
//		converter.setObjectMapper(JacksonMapper.nonEmptyMapper);
//		return new HttpMessageConverters(converter);
//	}
	 //JMS 使用 删除同上
//	@Bean
//	public MessageConverter customMessageConvert() {
//		return new Jackson2JsonMessageConverter();
//	}

	@Bean
	public RabbitListenerContainerFactory<?> rabbitListenerContainerFactory(ConnectionFactory connectionFactory) {
		SimpleRabbitListenerContainerFactory factory = new SimpleRabbitListenerContainerFactory();
		factory.setConnectionFactory(connectionFactory);
		factory.setMessageConverter(new Jackson2JsonMessageConverter());
		factory.setAcknowledgeMode(AcknowledgeMode.MANUAL);
		return factory;
	}

}
